#include <sys/time.h>
#include "conrt.h"

#ifndef T_OUT
#define T_OUT 20
#endif

extern int seq;

int send_message(m_rtmsg *msg) {
    int writedone=0;
    int t_out = T_OUT;
    int seqno=0;
    int status;
    int pid;
    int l;
    extern int rtsock;
    extern int kq; /*Our kqueue */
    extern struct kevent *events;
    struct timespec *timebegin;
    struct timespec *timeleft;
    int num_events;
    
    timebegin =(struct timespec *)Malloc(sizeof(struct timespec));
    timeleft = (struct timespec *)Malloc(sizeof(struct timespec));
    while (writedone==0) {
	if (Get_time(timebegin))
	    err_sys("Couldn't get system time");
        timeleft->tv_sec=T_OUT;
	timeleft->tv_nsec=0;
        /* Try to write and read socket*/
        pid = msg->m_rtm.rtm_pid = getpid();
	msg->m_rtm.rtm_seq =seqno=seq++;
	Write(rtsock,(char *)msg,msg->m_rtm.rtm_msglen);
        while (update_timeout(timeleft,timebegin)){
            num_events=Kevent(kq,NULL,0,events,1,timeleft);
	    if (num_events > 0) {
        	do {
                    l = read(rtsock, (char *)msg, sizeof(m_rtmsg));
                } while (l > 0 && (msg->m_rtm.rtm_seq != seqno || msg->m_rtm.rtm_pid != pid));
	    }
	    else 
		break;
            if (msg->m_rtm.rtm_errno != 0) 
                err_msg("route Message failed");
	    else {
		writedone=1;
		break;
	    }
	}
    }
}

int send_op(Rpointer p,int op) {
    m_rtmsg		*msg;
    struct rt_msghdr    *rtm;
    struct sockaddr_in  *sin,*sin2;
    struct sockaddr_dl  *sdl,*sdl2;
    char 	*cp;
    int length;
    struct sockaddr	*sa;
    int i;

    msg = (m_rtmsg*)Calloc(1,sizeof(m_rtmsg));
    rtm = (struct rt_msghdr *)msg;
    if (op==RTM_DELETE)
	rtm->rtm_type=RTM_DELETE;
    else if (op==RTM_ADD)
	rtm->rtm_type=RTM_ADD;
    else
	rtm->rtm_type=RTM_GET;
    rtm->rtm_version=RTM_VERSION;
    rtm->rtm_inits=0;
    rtm->rtm_msglen=sizeof(struct rt_msghdr);
    rtm->rtm_addrs=RTA_DST;
    if ((op==RTM_DELETE) || (op==RTM_ADD)) {
	if (p->type==ROUTE_ETH)
	    if (send_op(p,RTM_GET)!=0)
		return -1;
	    rtm->rtm_addrs|=RTA_GATEWAY|RTA_NETMASK ;
	switch (p->type) {
	case (ROUTE_INET):
	    rtm->rtm_flags=RTF_UP|RTF_GATEWAY|RTF_STATIC;
	    break;
	case (ROUTE_IFACE):
	    rtm->rtm_flags=RTF_UP|RTF_STATIC;
	    break;
	case (ROUTE_ETH):
	    rtm->rtm_flags=RTF_UP|RTF_STATIC|RTF_LLINFO|RTF_HOST;
	    break;
        }
    }
    /* Our addresses are already ready just copy them using sa->len */
    cp = (char *)(rtm+1);
    sa = (struct sockaddr *)&(p->dst);
    memcpy(cp,sa,sa->sa_len);
    rtm->rtm_msglen+=sa->sa_len;
    if ((op==RTM_DELETE) || (op==RTM_ADD)) {
        cp+=sa->sa_len;
        sa = (struct sockaddr *)&(p->gateway);
        memcpy(cp,sa,sa->sa_len);
        rtm->rtm_msglen+=sa->sa_len;
        cp+=sa->sa_len;
        sa = (struct sockaddr *)&(p->netmask);
        memcpy(cp,sa,sa->sa_len);
        rtm->rtm_msglen+=sa->sa_len;
    }
    send_message(msg);
    if (op==RTM_GET) {
	sin2 = (struct sockaddr_in *)(rtm+1);
        sdl2 = (struct sockaddr_dl *)(ROUNDUP(sin2->sin_len) + (char *)sin2);
	sdl = (struct sockaddr_dl *)(&(p->gateway));
	sin = (struct sockaddr_in *)(&(p->dst));
	   /* In responce we can see the interface name+index for out sdl */
	if (sin->sin_addr.s_addr == sin2->sin_addr.s_addr) {
            if (sdl2->sdl_family == AF_LINK &&
	        (rtm->rtm_flags & RTF_LLINFO) &&
	        !(rtm->rtm_flags & RTF_GATEWAY) &&
	        (sdl2->sdl_type == IFT_ETHER) || (sdl2->sdl_type == IFT_L2VLAN)) {}
	    else {
	        err_msg("Can only do a proxy for that");	
	        p->not_allowed=1;
	        return -1;
	    }
	}
	sdl->sdl_type=sdl2->sdl_type;
        sdl->sdl_index=sdl2->sdl_index;
    }
    free(msg);
    return 0; 
}